﻿using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;
using BlazorTraining.Shared.Products;

namespace BlazorTraining.Client.Services
{
    public class ProductService
    {
        public static async Task<IList<Category>> GetCategoriesAsync()
        {
            return await Task.Run(() => Categories);
        }

        public static async Task<Product> GetProductAsync(int productId)
        {
            var allProducts = Categories.SelectMany(c => c.Products);
            return await Task.Run(() => allProducts.FirstOrDefault(p => p.ProductId == productId));
        }

        private static IList<Category> Categories => new List<Category>
        {
            new Category
            {
                CategoryId = 1,
                CategoryName = "Beverages",
                Description = "Soft drinks, coffees, teas, beers, and ales",
                Products = new List<Product>
                {
                    new Product
                    {
                        ProductId = 1,
                        CategoryId = 1,
                        ProductName = "Chai",
                        QuantityPerUnit = "10 boxes x 20 bags",
                        UnitPrice = 18
                    },
                    new Product
                    {
                        ProductId = 2,
                        CategoryId = 1,
                        ProductName = "Chang",
                        QuantityPerUnit = "24 - 12 oz bottles",
                        UnitPrice = 19
                    },
                    new Product
                    {
                        ProductId = 24,
                        CategoryId = 1,
                        ProductName = "GuaranÃ¡ FantÃ¡stica",
                        QuantityPerUnit = "12 - 355 ml cans",
                        UnitPrice = 4.5M
                    },
                    new Product
                    {
                        ProductId = 34,
                        CategoryId = 1,
                        ProductName = "Sasquatch Ale",
                        QuantityPerUnit = "24 - 12 oz bottles",
                        UnitPrice = 14
                    },
                    new Product
                    {
                        ProductId = 35,
                        CategoryId = 1,
                        ProductName = "Steeleye Stout",
                        QuantityPerUnit = "24 - 12 oz bottles",
                        UnitPrice = 18
                    },
                    new Product
                    {
                        ProductId = 38,
                        CategoryId = 1,
                        ProductName = "CÃ´te de Blaye",
                        QuantityPerUnit = "12 - 75 cl bottles",
                        UnitPrice = 263.5M
                    },
                    new Product
                    {
                        ProductId = 39,
                        CategoryId = 1,
                        ProductName = "Chartreuse verte",
                        QuantityPerUnit = "750 cc per bottle",
                        UnitPrice = 18
                    },
                    new Product
                    {
                        ProductId = 43,
                        CategoryId = 1,
                        ProductName = "Ipoh Coffee",
                        QuantityPerUnit = "16 - 500 g tins",
                        UnitPrice = 46
                    },
                    new Product
                    {
                        ProductId = 67,
                        CategoryId = 1,
                        ProductName = "Laughing Lumberjack Lager",
                        QuantityPerUnit = "24 - 12 oz bottles",
                        UnitPrice = 14
                    },
                    new Product
                    {
                        ProductId = 70,
                        CategoryId = 1,
                        ProductName = "Outack Lager",
                        QuantityPerUnit = "24 - 355 ml bottles",
                        UnitPrice = 15
                    },
                    new Product
                    {
                        ProductId = 75,
                        CategoryId = 1,
                        ProductName = "RhÃ¶nbrÃ¤u Klosterbier",
                        QuantityPerUnit = "24 - 0.5 l bottles",
                        UnitPrice = 7.75M
                    },
                    new Product
                    {
                        ProductId = 76,
                        CategoryId = 1,
                        ProductName = "LakkalikÃ¶Ã¶ri",
                        QuantityPerUnit = "500 ml",
                        UnitPrice = 18
                    }
                }
            },
            new Category
            {
                CategoryId = 2,
                CategoryName = "Condiments",
                Description = "Sweet and savory sauces, relishes, spreads, and seasonings",
                Products = new List<Product>
                {
                    new Product
                    {
                        ProductId = 3,
                        CategoryId = 2,
                        ProductName = "Aniseed Syrup",
                        QuantityPerUnit = "12 - 550 ml bottles",
                        UnitPrice = 10
                    },
                    new Product
                    {
                        ProductId = 4,
                        CategoryId = 2,
                        ProductName = "Chef Anton's Cajun Seasoning",
                        QuantityPerUnit = "48 - 6 oz jars",
                        UnitPrice = 22
                    },
                    new Product
                    {
                        ProductId = 5,
                        CategoryId = 2,
                        ProductName = "Chef Anton's Gumbo Mix",
                        QuantityPerUnit = "36 boxes",
                        UnitPrice = 21.35M
                    },
                    new Product
                    {
                        ProductId = 6,
                        CategoryId = 2,
                        ProductName = "Grandma's Boysenberry Spread",
                        QuantityPerUnit = "12 - 8 oz jars",
                        UnitPrice = 25
                    },
                    new Product
                    {
                        ProductId = 8,
                        CategoryId = 2,
                        ProductName = "Northwoods Cranberry Sauce",
                        QuantityPerUnit = "12 - 12 oz jars",
                        UnitPrice = 40
                    },
                    new Product
                    {
                        ProductId = 15,
                        CategoryId = 2,
                        ProductName = "Genen Souyu",
                        QuantityPerUnit = "24 - 250 ml bottles",
                        UnitPrice = 15.5M
                    },
                    new Product
                    {
                        ProductId = 44,
                        CategoryId = 2,
                        ProductName = "Gula Malacca",
                        QuantityPerUnit = "20 - 2 kg bags",
                        UnitPrice = 19.45M
                    },
                    new Product
                    {
                        ProductId = 61,
                        CategoryId = 2,
                        ProductName = "Sirop d'Ã©rable",
                        QuantityPerUnit = "24 - 500 ml bottles",
                        UnitPrice = 28.5M
                    },
                    new Product
                    {
                        ProductId = 63,
                        CategoryId = 2,
                        ProductName = "Veggie-spread",
                        QuantityPerUnit = "15 - 625 g jars",
                        UnitPrice = 43.9M
                    },
                    new Product
                    {
                        ProductId = 65,
                        CategoryId = 2,
                        ProductName = "louisiana Fiery Hot Pepper Sauce",
                        QuantityPerUnit = "32 - 8 oz bottles",
                        UnitPrice = 21.05M
                    },
                    new Product
                    {
                        ProductId = 66,
                        CategoryId = 2,
                        ProductName = "Louisiana Hot Spiced Okra",
                        QuantityPerUnit = "24 - 8 oz jars",
                        UnitPrice = 17
                    },
                    new Product
                    {
                        ProductId = 77,
                        CategoryId = 2,
                        ProductName = "Original Frankfurter grÃ¼ne SoÃŸe",
                        QuantityPerUnit = "12 boxes",
                        UnitPrice = 13
                    }
                }
            },
            new Category
            {
                CategoryId = 3,
                CategoryName = "Confections",
                Description = "Desserts, candies, and sweet breads",
                Products = new List<Product>
                {
                    new Product
                    {
                        ProductId = 16,
                        CategoryId = 3,
                        ProductName = "Pavlova",
                        QuantityPerUnit = "32 - 500 g boxes",
                        UnitPrice = 17.45M
                    },
                    new Product
                    {
                        ProductId = 19,
                        CategoryId = 3,
                        ProductName = "Teatime Chocolate Biscuits",
                        QuantityPerUnit = "10 boxes x 12 pieces",
                        UnitPrice = 9.2M
                    },
                    new Product
                    {
                        ProductId = 20,
                        CategoryId = 3,
                        ProductName = "Sir Rodney's Marmalade",
                        QuantityPerUnit = "30 gift boxes",
                        UnitPrice = 81
                    },
                    new Product
                    {
                        ProductId = 21,
                        CategoryId = 3,
                        ProductName = "Sir Rodney's Scones",
                        QuantityPerUnit = "24 pkgs. x 4 pieces",
                        UnitPrice = 10
                    },
                    new Product
                    {
                        ProductId = 25,
                        CategoryId = 3,
                        ProductName = "NuNuCa NuÃŸ-Nougat-Creme",
                        QuantityPerUnit = "20 - 450 g glasses",
                        UnitPrice = 14
                    },
                    new Product
                    {
                        ProductId = 26,
                        CategoryId = 3,
                        ProductName = "GumbÃ¤r GummibÃ¤rchen",
                        QuantityPerUnit = "100 - 250 g bags",
                        UnitPrice = 31.23M
                    },
                    new Product
                    {
                        ProductId = 27,
                        CategoryId = 3,
                        ProductName = "Schoggi Schokolade",
                        QuantityPerUnit = "100 - 100 g pieces",
                        UnitPrice = 43.9M
                    },
                    new Product
                    {
                        ProductId = 47,
                        CategoryId = 3,
                        ProductName = "Zaanse koeken",
                        QuantityPerUnit = "10 - 4 oz boxes",
                        UnitPrice = 9.5M
                    },
                    new Product
                    {
                        ProductId = 48,
                        CategoryId = 3,
                        ProductName = "Chocolade",
                        QuantityPerUnit = "10 pkgs.",
                        UnitPrice = 12.75M
                    },
                    new Product
                    {
                        ProductId = 49,
                        CategoryId = 3,
                        ProductName = "Maxilaku",
                        QuantityPerUnit = "24 - 50 g pkgs.",
                        UnitPrice = 20
                    },
                    new Product
                    {
                        ProductId = 50,
                        CategoryId = 3,
                        ProductName = "Valkoinen suklaa",
                        QuantityPerUnit = "12 - 100 g bars",
                        UnitPrice = 16.25M
                    },
                    new Product
                    {
                        ProductId = 62,
                        CategoryId = 3,
                        ProductName = "Tarte au sucre",
                        QuantityPerUnit = "48 pies",
                        UnitPrice = 4.3M
                    },
                    new Product
                    {
                        ProductId = 68,
                        CategoryId = 3,
                        ProductName = "Scottish Longbreads",
                        QuantityPerUnit = "10 boxes x 8 pieces",
                        UnitPrice = 12.5M
                    }
                }
            },
            new Category
            {
                CategoryId = 4,
                CategoryName = "Dairy Products",
                Description = "Cheeses",
                Products = new List<Product>
                {
                    new Product
                    {
                        ProductId = 11,
                        CategoryId = 4,
                        ProductName = "Queso Cabrales",
                        QuantityPerUnit = "1 kg pkg.",
                        UnitPrice = 21
                    },
                    new Product
                    {
                        ProductId = 12,
                        CategoryId = 4,
                        ProductName = "Queso Manchego La Pastora",
                        QuantityPerUnit = "10 - 500 g pkgs.",
                        UnitPrice = 38
                    },
                    new Product
                    {
                        ProductId = 31,
                        CategoryId = 4,
                        ProductName = "Gorgonzola Telino",
                        QuantityPerUnit = "12 - 10 g pkgs",
                        UnitPrice = 12.5M
                    },
                    new Product
                    {
                        ProductId = 32,
                        CategoryId = 4,
                        ProductName = "Mascarpone Fabioli",
                        QuantityPerUnit = "24 - 200 g pkgs.",
                        UnitPrice = 32
                    },
                    new Product
                    {
                        ProductId = 33,
                        CategoryId = 4,
                        ProductName = "Geitost",
                        QuantityPerUnit = "500 g",
                        UnitPrice = 2.5M
                    },
                    new Product
                    {
                        ProductId = 59,
                        CategoryId = 4,
                        ProductName = "Raclette Courdavault",
                        QuantityPerUnit = "5 kg pkg.",
                        UnitPrice = 55
                    },
                    new Product
                    {
                        ProductId = 60,
                        CategoryId = 4,
                        ProductName = "Camembert Pierrot",
                        QuantityPerUnit = "15 - 300 g rounds",
                        UnitPrice = 34
                    },
                    new Product
                    {
                        ProductId = 69,
                        CategoryId = 4,
                        ProductName = "Gudbrandsdalsost",
                        QuantityPerUnit = "10 kg pkg.",
                        UnitPrice = 36
                    },
                    new Product
                    {
                        ProductId = 71,
                        CategoryId = 4,
                        ProductName = "FlÃ¸temysost",
                        QuantityPerUnit = "10 - 500 g pkgs.",
                        UnitPrice = 21.5M
                    },
                    new Product
                    {
                        ProductId = 72,
                        CategoryId = 4,
                        ProductName = "Mozzarella di Giovanni",
                        QuantityPerUnit = "24 - 200 g pkgs.",
                        UnitPrice = 34.8M
                    }
                }
            },
            new Category
            {
                CategoryId = 5,
                CategoryName = "Grains/Cereals",
                Description = "Breads, crackers, pasta, and cereal",
                Products = new List<Product>
                {
                    new Product
                    {
                        ProductId = 22,
                        CategoryId = 5,
                        ProductName = "Gustaf's KnÃ¤ckebrÃ¶d",
                        QuantityPerUnit = "24 - 500 g pkgs.",
                        UnitPrice = 21
                    },
                    new Product
                    {
                        ProductId = 23,
                        CategoryId = 5,
                        ProductName = "TunnbrÃ¶d",
                        QuantityPerUnit = "12 - 250 g pkgs.",
                        UnitPrice = 9
                    },
                    new Product
                    {
                        ProductId = 42,
                        CategoryId = 5,
                        ProductName = "Singaporean Hokkien Fried Mee",
                        QuantityPerUnit = "32 - 1 kg pkgs.",
                        UnitPrice = 14
                    },
                    new Product
                    {
                        ProductId = 52,
                        CategoryId = 5,
                        ProductName = "Filo Mix",
                        QuantityPerUnit = "16 - 2 kg boxes",
                        UnitPrice = 7
                    },
                    new Product
                    {
                        ProductId = 56,
                        CategoryId = 5,
                        ProductName = "Gnocchi di nonna Alice",
                        QuantityPerUnit = "24 - 250 g pkgs.",
                        UnitPrice = 38
                    },
                    new Product
                    {
                        ProductId = 57,
                        CategoryId = 5,
                        ProductName = "Ravioli Angelo",
                        QuantityPerUnit = "24 - 250 g pkgs.",
                        UnitPrice = 19.5M
                    },
                    new Product
                    {
                        ProductId = 64,
                        CategoryId = 5,
                        ProductName = "Wimmers gute SemmelknÃ¶del",
                        QuantityPerUnit = "20 bags x 4",
                        UnitPrice = 33.25M
                    }
                }
            },
            new Category
            {
                CategoryId = 6,
                CategoryName = "Meat/Poultry",
                Description = "Prepared meats",
                Products = new List<Product>
                {
                    new Product
                    {
                        ProductId = 9,
                        CategoryId = 6,
                        ProductName = "Mishi Kobe Niku",
                        QuantityPerUnit = "18 - 500 g pkgs.",
                        UnitPrice = 97
                    },
                    new Product
                    {
                        ProductId = 17,
                        CategoryId = 6,
                        ProductName = "Alice Mutton",
                        QuantityPerUnit = "20 - 1 kg tins",
                        UnitPrice = 39
                    },
                    new Product
                    {
                        ProductId = 29,
                        CategoryId = 6,
                        ProductName = "ThÃ¼ringer Rostbratwurst",
                        QuantityPerUnit = "50 bags x 30 sausgs.",
                        UnitPrice = 123.79M
                    },
                    new Product
                    {
                        ProductId = 53,
                        CategoryId = 6,
                        ProductName = "Perth Pasties",
                        QuantityPerUnit = "48 pieces",
                        UnitPrice = 32.8M
                    },
                    new Product
                    {
                        ProductId = 54,
                        CategoryId = 6,
                        ProductName = "TourtiÃ¨re",
                        QuantityPerUnit = "16 pies",
                        UnitPrice = 7.45M
                    },
                    new Product
                    {
                        ProductId = 55,
                        CategoryId = 6,
                        ProductName = "PÃ¢tÃ© chinois",
                        QuantityPerUnit = "24 boxes x 2 pies",
                        UnitPrice = 24
                    }
                }
            },
            new Category
            {
                CategoryId = 7,
                CategoryName = "Produce",
                Description = "Dried fruit and bean curd",
                Products = new List<Product>
                {
                    new Product
                    {
                        ProductId = 7,
                        CategoryId = 7,
                        ProductName = "Uncle Bob's Organic Dried Pears",
                        QuantityPerUnit = "12 - 1 lb pkgs.",
                        UnitPrice = 30
                    },
                    new Product
                    {
                        ProductId = 14,
                        CategoryId = 7,
                        ProductName = "Tofu",
                        QuantityPerUnit = "40 - 100 g pkgs.",
                        UnitPrice = 23.25M
                    },
                    new Product
                    {
                        ProductId = 28,
                        CategoryId = 7,
                        ProductName = "RÃ¶ssle Sauerkraut",
                        QuantityPerUnit = "25 - 825 g cans",
                        UnitPrice = 45.6M
                    },
                    new Product
                    {
                        ProductId = 51,
                        CategoryId = 7,
                        ProductName = "Manjimup Dried Apples",
                        QuantityPerUnit = "50 - 300 g pkgs.",
                        UnitPrice = 53
                    },
                    new Product
                    {
                        ProductId = 74,
                        CategoryId = 7,
                        ProductName = "Longlife Tofu",
                        QuantityPerUnit = "5 kg pkg.",
                        UnitPrice = 10
                    }
                }
            },
            new Category
            {
                CategoryId = 8,
                CategoryName = "Seafood",
                Description = "Seaweed and fish",
                Products = new List<Product>
                {
                    new Product
                    {
                        ProductId = 10,
                        CategoryId = 8,
                        ProductName = "Ikura",
                        QuantityPerUnit = "12 - 20 ml jars",
                        UnitPrice = 31
                    },
                    new Product
                    {
                        ProductId = 13,
                        CategoryId = 8,
                        ProductName = "Konbu",
                        QuantityPerUnit = "2 kg box",
                        UnitPrice = 6
                    },
                    new Product
                    {
                        ProductId = 18,
                        CategoryId = 8,
                        ProductName = "Carnavon Tigers",
                        QuantityPerUnit = "16 kg pkg.",
                        UnitPrice = 62.5M
                    },
                    new Product
                    {
                        ProductId = 30,
                        CategoryId = 8,
                        ProductName = "Nord-Ost Matjeshering",
                        QuantityPerUnit = "10 - 200 g glasses",
                        UnitPrice = 25.89M
                    },
                    new Product
                    {
                        ProductId = 36,
                        CategoryId = 8,
                        ProductName = "Inlagd Sill",
                        QuantityPerUnit = "24 - 250 g jars",
                        UnitPrice = 19
                    },
                    new Product
                    {
                        ProductId = 37,
                        CategoryId = 8,
                        ProductName = "Gravad lax",
                        QuantityPerUnit = "12 - 500 g pkgs.",
                        UnitPrice = 26
                    },
                    new Product
                    {
                        ProductId = 40,
                        CategoryId = 8,
                        ProductName = "Boston Crab Meat",
                        QuantityPerUnit = "24 - 4 oz tins",
                        UnitPrice = 18.4M
                    },
                    new Product
                    {
                        ProductId = 41,
                        CategoryId = 8,
                        ProductName = "Jack's New England Clam Chowder",
                        QuantityPerUnit = "12 - 12 oz cans",
                        UnitPrice = 9.65M
                    },
                    new Product
                    {
                        ProductId = 45,
                        CategoryId = 8,
                        ProductName = "RÃ¸gede sild",
                        QuantityPerUnit = "1k pkg.",
                        UnitPrice = 9.5M
                    },
                    new Product
                    {
                        ProductId = 46,
                        CategoryId = 8,
                        ProductName = "Spegesild",
                        QuantityPerUnit = "4 - 450 g glasses",
                        UnitPrice = 12
                    },
                    new Product
                    {
                        ProductId = 58,
                        CategoryId = 8,
                        ProductName = "Escargots de Bourgogne",
                        QuantityPerUnit = "24 pieces",
                        UnitPrice = 12
                    },
                    new Product
                    {
                        ProductId = 73,
                        CategoryId = 8,
                        ProductName = "RÃ¶d Kaviar",
                        QuantityPerUnit = "24 - 150 g jars",
                        UnitPrice = 15
                    }
                }
            }
        };

    }
}
